#include "codegen/MachineBlock.hpp"
#include "BasicBlock.h"

void MachineBlock::output(std::ostream &os) const {
    if (IRBlock->label.substr(0, 9) == ("mainEntry")) os << "main:\n";
    else {
        if(IRBlock->label.find("Entry") != string::npos){
            unsigned long len = IRBlock->label.length();
            os << IRBlock->label.substr(0,len-6) << ":\n";
        }else
            os << IRBlock->label << ":\n";
    }
    for (auto inst : inst_list) {
        inst->output(os);
        if (inst->no != -1 ) os << "\t\t\t\t# " << inst->no;
        os << "\n";
    }
    os << "\n";
}